-- sign_ext.vhd
-- Lab 3
-- Team CART
-- CSE 132L
-- The sign extension unit performs sign extension on the 16-bit immediate
-- value in the instruction to produce a 32-bit value that can be used as
-- the second operand of the ALU.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.lab3_pack.all;

entity sign_ext is
    Port ( input : in  STD_LOGIC_VECTOR (NIMM-1 downto 0);
           output : out  STD_LOGIC_VECTOR (NBIT-1 downto 0));
end sign_ext;

architecture Dataflow of sign_ext is

signal extension : std_logic_vector (NBIT-NIMM-1 downto 0);

begin

	extension <= (others => input(15));
	output <= extension & input;

end Dataflow;

