module mux_tb();

	/* local declaration */
	logic		s;
	logic[1:0]	a;
	logic[1:0]	b;

	wire[1:0]	o;
  
	/* instantiate a mux module */
	mux #(2) M1(
		.s(s),
		.a(a),
		.b(b),
		.o(o)
	);


initial 
begin

	/* initialize values */
	a = 2'd3;
	b = 2'd2;
	
	/* select input a */
	s = 1'b0;
	#10;

	/* select input b */
	s = 1'b1;
	#10;

	$finish;
end

endmodule
