-- prog_counter.vhd
-- Lab 3
-- Team CART
-- CSE 132L
-- The program counter block's register will be incremented by an adder every clock cycle.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.lab4_pack.all;

entity reg is
generic (
    size : integer := 32
);
port (
    clk : in  std_logic;
    en : in std_logic;
    rst : in  std_logic;
    d : in std_logic_vector(size-1 downto 0);
    q : out std_logic_vector(size-1 downto 0)
);
end reg;

architecture Behavioral of reg is

begin

	Process (clk)
	begin
		if (clk'event and clk = '1') then
                    if (rst = '1') then
                        q <= (others => '0');
                    elsif (en = '1') then
                        q <= d;
                    end if;
	        end if;
	end Process;

end Behavioral;

