library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity shifter is
    generic (
        size : integer := 32;
        amt : integer := 2
    );
    port (
        a : in std_logic_vector(size-1 downto 0);
        o : out std_logic_vector(size-1 downto 0)
    );
end shifter;

architecture Behavioral of shifter is
begin

    o <= std_logic_vector(unsigned(a) sll amt);

end Behavioral;
