library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use work.lab5_pack.all;

entity writeback_fetch_reg is
port (
clk : in std_logic;
rst : in std_logic;
en : in std_logic;
PC_p : in STD_LOGIC_VECTOR (NBIT-1 downto 0);
PCF : out std_logic_vector(NBIT-1 downto 0)
);
end writeback_fetch_reg;

architecture Behavioral of writeback_fetch_reg is
begin
    Process (clk)
    begin
        if (clk'event and clk = '1') then
            if rst = '1' then
                PCF <= (others => '0');
            elsif en = '1' then
                PCF <= PC_p;
            end if;
        end if;
    end Process;
end Behavioral;
