library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use work.lab5_pack.all;

entity fetch_decode_reg is
port (
    clk : in std_logic;
    rst : in std_logic;
    en : in std_logic;
    InstrF : in std_logic_vector(NBIT-1 downto 0);
    PCPlus4F : in std_logic_vector(NBIT-1 downto 0);
    InstrD : out std_logic_vector(NBIT-1 downto 0);
    PCPlus4D : out std_logic_vector(NBIT-1 downto 0)
);
end fetch_decode_reg;

architecture Behavioral of fetch_decode_reg is
begin
    Process (clk)
    begin
        if (clk'event and clk = '1') then
            if rst = '1' then
                InstrD <= (others => '0');
                PCPlus4D <= (others => '0');
            elsif en = '1' then
                InstrD <= InstrF;
                PCPlus4D <= PCPlus4F;
            end if;
        end if;
    end Process;
end Behavioral;
