LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;


ENTITY shifter IS
	GENERIC(
		SIZE: INTEGER := 32;
		AMT: INTEGER := 2
	);
	PORT(
	    a : IN STD_LOGIC_VECTOR(SIZE-1 DOWNTO 0);
	    o : OUT STD_LOGIC_VECTOR(SIZE-1 DOWNTO 0)
	);

END shifter;

ARCHITECTURE Behavioral OF shifter IS
BEGIN

	o <= std_logic_vector(unsigned(a) sll AMT);

END Behavioral;
 
