-- prog_counter.vhd
-- Lab 3
-- Team CART
-- CSE 132L
-- The program counter block's register will be incremented by an adder every clock cycle.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.lab3_pack.all;

entity reg is
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           d : in STD_LOGIC_VECTOR (NBIT-1 DOWNTO 0);
           q : out  STD_LOGIC_VECTOR (NBIT-1 downto 0));
end reg;

architecture Behavioral of reg is

begin

	Process (clk)
	begin
		if (clk'event and clk = '1') then
                    if (rst = '1') then
                        q <= (others => '0');
                    else
                        q <= d;
                    end if;
	        end if;
	end Process;

end Behavioral;

