-- adder.vhd
-- Lab 3
-- Team CART
-- CSE 132L
-- The adder block adds two unsigned 32-bit values.

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;
use work.lab3_pack.all;

ENTITY adder IS

	PORT (
		a :	IN std_logic_vector(NBIT-1 DOWNTO 0);
		b : IN std_logic_vector(NBIT-1 DOWNTO 0);
		c : OUT std_logic_vector(NBIT-1 DOWNTO 0)
	);
END adder;

ARCHITECTURE Behavioral OF adder IS

BEGIN

	c <= std_logic_vector(signed(a) + signed(b));

END Behavioral;
