module adder_tb();

	/* local declaration */
	logic[31:0] a;
	logic[31:0] b;

	wire[31:0] c;
 
	/* instantiate an adder module */
	adder A1(
		.a(a),
		.b(b),
		.c(c)
	);


initial 
begin

	/* 0 + 0 */
	a = 32'h00000000;
	b = 32'h00000000;
	#10;

	/* 0 + 4 */
	b = 32'h00000004;
	#10;

	/* 2 + 4 */
	b = 32'hffffffff;
	#10;

	/* 8 + 8 */
	a = 32'h00000001;
	#10;

	$finish;

end

endmodule
